# -*- coding: utf-8 -*-
"""
'Activité 3 : Identification d'un modèle
Mathieu Nierenberger
"""
import matplotlib.pyplot as plt		# pour le tracé des graphes
import numpy as np

#  Import des données de l'activité 2 :
data_speed = np.load('data_speed.npz')
td = data_speed['td']
vxd = data_speed['vxd']
vyd = data_speed['vyd']

#####################   IDENTIFICATION MODELE LINEAIRE   ###########################

from sklearn.linear_model import SGDRegressor
tdd = np.asarray(td)
tdd = tdd.reshape(len(tdd), 1)    # transformation en un dataset (1 seul attribut)
model=SGDRegressor(max_iter=10000,tol=1e-4)	# LIGNE A MODIFIER - création du modèle linéaire
model.fit(tdd,vxd) 		# entraînement du modèle
vxd_predit=model.predict(tdd) 	# prédiction sur X
print("coef. directeur =",model.coef_) # affiche l'éq
print("ordonnée à l'origine =",model.intercept_) 
print("coefficient de détermination R² = ",model.score(tdd,vxd))

plt.figure(4) 		# crée une nouvelle figure
plt.scatter(td,vxd, label="vx(t)",s=2) 	# Tracé de vx(t)
#plt.scatter(td,vyd, label="vy(t)") 	# Tracé de vy(t)
plt.plot(td,vxd_predit,'-', label="vx(t) modèle") 	# tracé du modèle appliqué à tdd
plt.grid() 		# affiche une grille de fond
plt.legend()
plt.xlabel("Temps (s)") 	# ajoute une étiquette pour les abscisses
plt.ylabel("Vitesse (m/s)") 	# ajoute une étiquette pour les ordonnées
plt.title("Vitesses en phase de décélération et modèle linéaire") 	# Titre du graphique
plt.savefig('4 - Vitesses décélération - régression linéaire.png', dpi=300)
plt.show()
