# -*- coding: utf-8 -*-
"""
'Activité 3 - suite : Réseau de neurones
Mathieu Nierenberger
"""
import matplotlib.pyplot as plt		# pour le tracé des graphes
import numpy as np

#  Import des données de l'activité 2 :
data_speed = np.load('data_speed.npz')
td = data_speed['td']
vxd = data_speed['vxd']
vyd = data_speed['vyd']
tdd = np.asarray(td)
tdd = tdd.reshape(len(tdd), 1)

#####################   UTILISATION D'UN RESEAU DE NEURONES   ###########################

from sklearn.neural_network import MLPRegressor # Multi Layer Perceptron Regressor
from sklearn.model_selection import train_test_split
tdd_train, tdd_test, vxd_train, vxd_test = train_test_split(tdd, vxd,test_size=0.33,random_state=1)
regr = MLPRegressor(random_state=1, max_iter=100000,hidden_layer_sizes = (2),activation='logistic',tol=1e-8).fit(tdd_train, vxd_train)
vxd_predict=regr.predict(tdd_test)
print('coefficient R² : ',regr.score(tdd_test, vxd_test))

plt.figure(5) 		# crée une nouvelle figure
plt.scatter(tdd_train,vxd_train, label="données d'entrainement",s=2,color='blue') 	# Représentation données d'entrainement
plt.scatter(tdd_test,vxd_test, label="données de test",s=2,color='green') 	# Représentation données test
plt.scatter(tdd_test,vxd_predict, label="valeurs prédites (<-> test)",s=2,color='red') 	# Représentation valeurs prédites associées aux données test
plt.grid() 		# affiche une grille de fond
plt.legend()
plt.xlabel("Temps (s)") 	# ajoute une étiquette pour les abscisses
plt.ylabel("Vitesse (m/s)") 	# ajoute une étiquette pour les abscisses
plt.title("Prédiction de la vitesse de décélération par un réseau de neurones") 	# Titre du graphique
plt.savefig('5 - Réseau de neurones.png', dpi=300)
plt.show()